package com.engine.junchuang.util.detach;

import org.apache.commons.collections4.CollectionUtils;
import org.apache.commons.lang3.StringUtils;
import weaver.conn.RecordSet;
import weaver.hrm.User;
import weaver.hrm.company.DepartmentComInfo;
import weaver.hrm.company.SubCompanyComInfo;

import java.util.*;

/**
 * @author:dxfeng
 * @createTime: 2022/10/28
 * @version: 1.0
 */
public class DetachUtil {
    private boolean DETACH = true;

    private final Set<String> companyIds = new HashSet<>();
    private final Set<String> departmentIds = new HashSet<>();

    public DetachUtil(User user) {
        if (1 == user.getUID() || user.isAdmin()) {
            DETACH = false;
        }
        if (DETACH) {
            try {
                RecordSet rs = new RecordSet();
                rs.executeQuery("select a.id, a.subcompanyid1 from hrmdepartment a inner join hrmdepartmentdefined b on a.id = b.deptid where a.id = ? or b.bmfzr = ? ", String.valueOf(user.getUserDepartment()), String.valueOf(user.getUID()));
                while (rs.next()) {
                    String departmentId = rs.getString("id");
                    String allSupDepartment = new DepartmentComInfo().getAllSupDepartment(departmentId);
                    if (StringUtils.isNotBlank(allSupDepartment)) {
                        List<String> ids = Arrays.asList(allSupDepartment.split(","));
                        departmentIds.addAll(ids);
                    }
                    ArrayList<String> childDeptIds = new ArrayList<>();
                    new DepartmentComInfo().getAllChildDeptByDepId(childDeptIds, departmentId);
                    departmentIds.addAll(childDeptIds);
                    departmentIds.add(departmentId);
                    String subCompanyId = rs.getString("subcompanyid1");
                    String allSupCompany = new SubCompanyComInfo().getAllSupCompany(subCompanyId);
                    if (StringUtils.isNotBlank(allSupCompany)) {
                        List<String> ids = Arrays.asList(allSupCompany.split(","));
                        companyIds.addAll(ids);
                    }
                    companyIds.add(subCompanyId);
                }
            } catch (Exception e) {
                throw new RuntimeException(e);
            }
        }
    }

    public boolean isDETACH() {
        return DETACH;
    }

    public String getCompanyIds() {
        if (CollectionUtils.isNotEmpty(companyIds)) {
            return StringUtils.join(companyIds, ",");
        }
        return "";
    }

    public String getDepartmentIds() {
        if (CollectionUtils.isNotEmpty(departmentIds)) {
            return StringUtils.join(departmentIds, ",");
        }
        return "";
    }
}
